#!/usr/local/bin/perl
########################################
# form-mail.cgi (ver. 0.5)
# 【   種別   】 フリーウェア
# 【  著作権  】 (C) Wataru Kanzaki, 2010
# 【   URL    】 http://www.wi-wi.jp/
########################################
# use strict('vars');
use CGI;
# use CGI::Carp qw/fatalsToBrowser/;
use Encode;
use Encode::Guess;
use lib './';
use Mailer;


my %ini = (
	owner => 'owner@example.com'			,# 宛先メールアドレス
	account => ''					,# 送信者アドレス（通常はmailtoと同じ）
	password => ''					,# 送信者アドレス（通常はmailtoと同じ）
	subject => 'フォームメール'		,# メール件名
	visitor => 1					,# 訪問者へのメールを送信するか。1:送信、0:送信しない
	vsubject => 'フォームメール'		 # 訪問者へのメールの件名
);



my $cgi=new CGI;

my %qs=(name=>$cgi->param('name')||'',
		pass=>$cgi->param('pass')||'',
		mail=>$cgi->param('mail')||'',
		message=>$cgi->param('message')||'',
		aspm=>&Antispam()
		);

&main();
exit();

##########
sub main {

print "Content-type: text/html; charset:UTF-8\n\n";
if(	$qs{'name'} eq '' or 
	$qs{'mail'} eq '' or 
	$qs{'message'} eq ''){
	&Form();
}elsif($qs{'pass'} ne $qs{'aspm'}){
	&Form();
}else{
	&Send();
	&Thanks();
}

}##

##########
sub Antispam {
	my @addr=split(',', $ENV{'REMOTE_ADDR'});
	return $addr[0]*16_777_216 + $addr[1]*65_536 + $addr[2]*256 + $addr[3]; # 256**3, 256**2, 256**1, 256**0
}##

##########
sub Form {
	my $mlS=Mailer->new(('debug'=>0));
	$mlS->Template('form.tmpl');
	$mlS->Body(%qs);
	$mlS->Print();

}##

##########
sub Thanks {

	my $ml=Mailer->new(('debug'=>0));
	$ml->Template('thanks.tmpl');
	$ml->Body(%qs);
	$ml->Print();


}##


##########
sub Send {
	my $enc=guess_encoding($qs{name}.$qs{message}, qw/euc-jp shiftjis 7bit-jis/);
	if(ref($enc) && ($enc->name ne 'utf8')){
		$qs{name}=decode($enc->name, $qs{name});
		$qs{message}=decode($enc->name, $qs{message});
	}

	my $ml=Mailer->new(('debug'=>1));
	$ml->Template('owner.tmpl');
	$ml->Mailto($ini{'owner'});
	$ml->Replyto($qs{'mail'});
	$ml->From($ini{'owner'});
	$ml->Subject($ini{'subject'});
	$ml->Body(%qs);
	$ml->Send();

	if($ini{'visitor'}){
		$ml=Mailer->new(('debug'=>2));
		$ml->Template('visitor.tmpl');
		$ml->Mailto($qs{'mail'});
		$ml->From($ini{'owner'});
		$ml->Subject($ini{'vsubject'});
		$ml->Body(%qs);
		$ml->Send();
	}
	
}##

